# Contributing

First, thank you for contributing! We love and encourge pull requests from everyone.

At this stage, we're still developing the initial drafts of all of the packages, using an
[RFC workflow](https://github.com/go-kit/kit/tree/master/rfc).

Before submitting major changes, here are a few guidelines to follow:

1. Check the [open issues][issues] and [pull requests][prs] for existing discussions.
1. Open an [issue][issues] to discuss a new feature.
1. Write tests.
1. Make sure the entire test suite passes locally and on Travis CI.
1. Open a Pull Request.
1. [Squash your commits][squash] after receiving feedback and add a [great commit message][message].
1. Have fun!

[issues]: https://github.com/go-kit/kit/issues
[prs]: https://github.com/go-kit/kit/pulls
[squash]: http://gitready.com/advanced/2009/02/10/squashing-commits-with-rebase.html
[message]: http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html

